﻿Type=StaticCode
Version=5.5
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub FormatMarkdown(Text As String) As String 
	Dim tempstr() As String, temp As Int, temp2 As Int, HTML As StringBuilder, CurrentLine As String, NextLine As String, IsInside As Int, LeftSide As String, RightSide As String  
	Text = Text.Replace("<BR>", CRLF)
	Text = Text.Replace("---", "&mdash;")
	Text = Text.Replace("\\", "&#92;")
	Text = Text.Replace("\`", "&#39;")
	Text = Text.Replace("\*", "&#42;")
	Text = Text.Replace("\_", "&#95;")
	Text = Text.Replace("\{", "&#123;")
	Text = Text.Replace("\}", "&#125;")
	Text = Text.Replace("\[", "&#91;")
	Text = Text.Replace("\]", "&#93;")
	Text = Text.Replace("\(", "&#40;")
	Text = Text.Replace("\)", "&#41;")
	Text = Text.Replace("\#", "&#35;")
	Text = Text.Replace("\+", "&#43;")
	Text = Text.Replace("\-", "&#45;")
	Text = Text.Replace("\.", "&#46;")
	Text = Text.Replace("\!", "&#33;")	
	Text = ProcessURLs(Text, "bad")
	Text = ProcessSuperscript(Text)
		
	Log("PHASE 3: " & Text)
	tempstr = Regex.Split(CRLF, Text)
	
	HTML.Initialize
	CurrentLine = tempstr(0)
	If tempstr.Length>1 Then NextLine = tempstr(1)
	For temp = 0 To tempstr.Length-1 
		LeftSide = GetLeftSide(CurrentLine, " ")
		RightSide = GetRightSide(CurrentLine, " ")
		If IsHR(CurrentLine) Then 
			HTML.Append(CRLF & "<HR>")
		else if IsQuote(CurrentLine) Then 
			HTML.Append(CRLF & "&quot;" & API.right(CurrentLine, CurrentLine.Length-1)  & "&quot;")
		else if IsListItem(CurrentLine, False) Then 
			If IsInside = 0 Then HTML.Append(CRLF & "<UL>")
			IsInside = 1
			HTML.Append(CRLF & "<LI>" & RightSide & "<LI>")
			If Not(IsListItem(NextLine, False)) Then 
				IsInside = 0
				If IsInside = 0 Then HTML.Append(CRLF & "</UL>")
			End If
		else if IsListItem(CurrentLine, True) Then 
			If IsInside = 0 Then HTML.Append(CRLF & "<OL>")
			IsInside = 2
			HTML.Append(CRLF & "<LI>" & RightSide & "<LI>")
			If Not(IsListItem(NextLine, True)) Then 
				IsInside = 0
				If IsInside = 0 Then HTML.Append(CRLF & "</OL>")
			End If
		Else if OnlyContains(NextLine, "=") Then 
			HTML.Append(CRLF & "<H1>" & CurrentLine & "</H1>")
			NextLine=""
		Else if OnlyContains(NextLine, "-") Then 
			HTML.Append(CRLF & "<H2>" & CurrentLine & "</H2>")	
			NextLine=""
		else if OnlyContains(LeftSide, "#") Then 
			temp2 = API.CountInstances2(LeftSide, "#")
			HTML.Append(CRLF & "<H" & temp2 & ">" & CurrentLine.Replace("#", "") & "</H" & temp2 & ">")	
		Else if NextLine.Length > 0 Then 
			HTML.Append(CRLF & CurrentLine)
		End If
		CurrentLine = NextLine
		If temp+1< tempstr.Length Then NextLine = tempstr(temp+1).Trim 
	Next
	
	Text = HTML.ToString.Replace(CRLF, CRLF & "<BR>")
	Text = Enclose(Text, "_", "U")
	Text = Enclose(Text, "~~", "strike")
	Text = Enclose(Text, "**", "B")
	Text = Enclose(Text, "*", "I")
	Return Text
End Sub

Sub Enclose(Text As String, Find As String, HTMLtag As String) As String 
	Do While Has2(Text, Find)
		Text = ReplaceNext(Text, 0, Find, "<" & HTMLtag & ">")
		Text = ReplaceNext(Text, 0, Find, "</" & HTMLtag & ">")
	Loop
	Return Text 
End Sub

Sub Has2(Text As String, Find As String) As Boolean 
	Dim instr As Int = API.Instr(Text, Find, 0) 
	If instr > -1 Then 
		instr = API.Instr(Text, Find, instr+1)
		Return instr > -1 
	End If
End Sub

Sub ReplaceNext(Text As String, Start As Int, ToFind As String, ToReplace As String) As String 
	Dim instr As Int = API.Instr(Text, ToFind, Start)
	If instr > -1 Then 
		Return API.Left(Text, instr) & ToReplace & API.Right(Text, Text.Length - instr - ToFind.Length)	
	End If
	Return Text 
End Sub

Sub IsHR(Text As String) As Boolean 
	Text = Text.trim.Replace(" ", "")
	Return OnlyContains(Text, "*-_") And Text.Length > 2
End Sub

Sub OnlyContains(Text As String, Characters As String) As Boolean
	Dim temp As Int, Character As String 
	If Text.Length = 0 Then Return False 
	For temp = 0 To Text.Length -1 
		Character = API.Mid(Text, temp, 1)	
		If Not(Characters.Contains(Character)) Then Return False 
	Next
	Return True 
End Sub
Sub IsListItem(Text As String, Numbered As Boolean) As Boolean 
	If Text.Length = 0 Then Return False 
	If Numbered Then 
		Text = GetLeftSide(Text, ".").Trim 
		Return IsNumber(Text) 
	Else 
		Return Text.StartsWith("*")
	End If
End Sub

Sub GetLeftSide(Text As String, Delimeter As String) As String
	Dim instr As Int 
	Text = Text.Trim
	instr = API.Instr(Text, Delimeter, 0)
	If instr > -1 Then Return API.Left(Text, instr).Trim 
End Sub
Sub GetRightSide(Text As String, Delimeter As String) As String
	Dim instr As Int 
	Text = Text.Trim
	instr = API.Instr(Text, Delimeter, 0)
	If instr > -1 Then Return API.right(Text, Text.Length-instr).Trim 
	Return Text 
End Sub

Sub IsQuote(Text As String) As Boolean
	Return API.Left(Text.Trim, 1) = ">" 
End Sub

Sub ProcessSuperscript(Text As String) As String 
	Dim instr As Int  = API.Instr(Text, "^", 0), SpaceChar As Int, CRLFchar As Int 
	Do Until instr = -1 
		Text = ReplaceNext(Text, 0, "^", "<SUP>")
		SpaceChar = API.Instr(Text, " ", instr) 
		CRLFchar = API.Instr(Text, CRLF, instr) 
		If SpaceChar > -1 And (SpaceChar < CRLFchar Or CRLFchar = -1) Then 
			Text = ReplaceNext(Text, instr, " ", "</SUP>")
		Else if CRLFchar > -1 Then 
			Text = ReplaceNext(Text, instr, CRLF, "</SUP>" & CRLF)
		Else 
			Text = Text & "</SUP>"
		End If
		instr  = API.Instr(Text, "^", 0)
	Loop
	Return Text 
End Sub

Sub ProcessURLs(Text As String, Class As String) As String
	Dim Start As Int, Middle As Int, Finish As Int, Cont As Boolean = True 
	Dim URL As String, Tempstr As String 
	Do While Cont '<http://www.url.com> 
		Start = API.Instr(Text, "<", Start)
		If Start > -1 Then
			Finish = API.Instr(Text, ">", Start)
			If Finish = -1 Then 
				Cont = False
			Else
				URL = API.Mid(Text, Start + 1, Finish - Start - 1)
				Tempstr = "<A HREF='" & URL & "' CLASS='" & Class & "'>" & URL & "</A>"
				Log("2: " & Tempstr)
				Text = API.Left(Text, Start) & Tempstr & API.Right(Text, Text.Length - Finish - 1)
				Start = Start + Tempstr.Length  
			End If
		End If
		If Cont Then Cont = Start > -1 
	Loop 
	Cont = True 
	Start = 0
	Do While Cont'[text!](http://www.url.com)
		Start = API.Instr(Text, "[", Start)
		If Start > -1 Then 
			Middle = API.Instr(Text, "](", Start)
			If Middle = -1 Then 
				Cont = False 
			Else 
				Finish = API.Instr(Text, ")", Middle)
				If Finish = -1 Then 
					Cont = False
				Else
					Tempstr = API.Mid(Text, Start+1, Middle - Start - 1)
					URL = API.Mid(Text, Middle + 2, Finish - Middle - 2)
					Tempstr = "<A HREF='" & URL & "' CLASS='" & Class & "'>" & Tempstr & "</A>"
					Log("1: " & Tempstr)
					Text = API.Left(Text, Start) & Tempstr & API.Right(Text, Text.Length - Finish - 1)
					Start = Finish 
				End If 	
			End If
		End If 
		If Cont Then Cont = Start > -1 
	Loop
	Return Text 
End Sub
	
	